
library(ggplot2)

#These come from msvar_generate_figures.R
tol = 1e-5
replics = num_reps
A = c(t( Ap ))
Pr = c(t( Prp ))
Sigma = c(t( Sp  ))
D = ncol(Sp)
M = ncol(Prp)
p = (ncol(Ap) - 1) / D

data_dir_0 = "../msvar_data_d40_"
#data_dir_0 = "../msvar_data_d20_"
penalty = c("mle_star", "lasso", "alasso", "scad", "mcp" )
penalty_n = c("1mle_star", "2lasso", "3alasso", "4scad", "5mcp" )
penalty_labs = c("MLE*", "LASSO", "ALASSO", "SCAD", "MCP" )
params_err = c("AR coefficients", "Covariance matrices", "Trans. probab. matrix", "Overall")
params_tr = params_err
gg_capt = ""
#ns = c("n200", "n300", "n400")
#nstr = c("200", "300", "400")
ns = c("n300", "n400", "n500")
nstr = c("300", "400", "500")

write( "Penalty,Sample size,Parameter,Relative EE Median", file = paste0("table_REE.csv"))
write( "Penalty,Sample size,Parameter,EE Median", file = paste0("table_EE_overall.csv"))
write( "Penalty,Sample size,Parameter,EE Median", file = paste0("table_EE_trans_probab.csv"))
write( "Penalty,Sample size,Parameter,TPR Median", file = paste0("table_TPR.csv"))
write( "Penalty,Sample size,Parameter,TNR Median", file = paste0("table_TNR.csv"))

{
    #matrix(0, nrow = num_ic * replics, ncol = length(penalty))
    err_A = matrix( 0, nrow = 0, ncol = length(penalty) )
    err_Pr = matrix( 0, nrow = 0, ncol = length(penalty) )
    err_S = matrix( 0, nrow = 0, ncol = length(penalty) )
    err_all = matrix( 0, nrow = 0, ncol = length(penalty) )
    tpr_A = matrix( 0, nrow = 0, ncol = length(penalty) )
    tnr_A = matrix( 0, nrow = 0, ncol = length(penalty) )
    tpr_S = matrix( 0, nrow = 0, ncol = length(penalty) )
    tnr_S = matrix( 0, nrow = 0, ncol = length(penalty) )
    tpr_all = matrix( 0, nrow = 0, ncol = length(penalty) )
    tnr_all = matrix( 0, nrow = 0, ncol = length(penalty) )
    const_vec = 1
    for(n in 1:length(ns))
    {
        N = as.numeric(nstr[n])
        A_nintercept = matrix(1, nrow = D * M, ncol = 1 + D * p)
        A_nintercept[,1] = 0
        A_nintercept = c(t( A_nintercept )) > 0
        S_ndiagonal = matrix(1, nrow = D * M, ncol = D)
        for(i in 1:M)
        {
            r = (i-1) * D + 1
            diag(S_ndiagonal[r:(r + D - 1),]) = 0
        }
        S_ndiagonal = c(t( S_ndiagonal )) > 0
        data_dir = paste0(data_dir_0, ns[n], "/" ,penalty[1])
        
        #Sigma_inv = c(t(as.matrix(read.table(paste0(data_dir,"/msvar_parameters_Sigma_inv")))))
        Sigma_inv = Sigma
        
        is_prec = F
        if ( grepl("_pr_", data_dir, fixed = T) )
        {
            is_prec = T
            params_err[2] = "Precision matrices"
            params_tr[2] = "Precision matrices"
        }
        
        err_A_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        err_Pr_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        err_S_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        err_all_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        tpr_A_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        tnr_A_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        tpr_S_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        tnr_S_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        tpr_all_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        tnr_all_tmp = matrix(0, nrow = replics, ncol = length(penalty))
        # Read results according to penalty (directory)
        for ( j in 1:length(penalty))
        {
            data_dir = paste0(data_dir_0, ns[n], "/", penalty[j])
            A_matrix = as.matrix(read.table(paste0(data_dir, "/msvar_estimates_coeff_matrix")))
            Pr_matrix = as.matrix(read.table(paste0(data_dir, "/msvar_estimates_probabs_matrix")))
            Sigma_matrix = as.matrix(read.table(paste0(data_dir, "/msvar_estimates_covar_prec_matrix")))
            
            #Sort
            for(ir in 1:nrow(Pr_matrix))
            {
                if(sum(Pr_matrix[ir,]) == 0)
                    next;
                v = rep(0, M)
                mt = matrix( A_matrix[ ir ,], nrow = M * D, byrow = T)
                for(i in 1:M)
                    v[i] = mean(mt[ (i - 1) * D + 1:D ,1])
                ind = sort(v, decreasing = T, index.return = T)$ix
                r = c(sapply(1:M, function(x) (ind[x]-1)*D + 1:D   ) )
                A_matrix[ir,] = c(t(mt[r,]))
                mt = matrix( Sigma_matrix[ ir ,], nrow = M * D, byrow = T)
                Sigma_matrix[ir,] = c(t(mt[r,]))
                mt = matrix( Pr_matrix[ ir ,], nrow = M, byrow = T)
                Pr_matrix[ir,] = c(t(mt[ind,ind]))
            }
            
            if(is_prec)
                Sigma_inv_matrix = Sigma_matrix
            
            err_A_tmp[,j] = sqrt( apply ( A_matrix, 1, function(ai) sum ( ( ai - A ) * ( ai - A) )  ) / sum( A * A ) )
            err_Pr_tmp[,j] = sqrt( apply ( Pr_matrix, 1, function(ai) sum ( ( ai - Pr ) * ( ai - Pr) )  ) / sum( Pr * Pr ) )
            
            tpr_A_tmp[,j] = apply ( A_matrix, 1, function(ai) sum ( abs(ai[A_nintercept]) > tol & abs(A[A_nintercept]) > tol )  ) / sum( abs(A[A_nintercept]) > tol )
            tnr_A_tmp[,j] = apply ( A_matrix, 1, function(ai) sum ( abs(ai[A_nintercept]) <= tol & abs(A[A_nintercept]) <= tol )  ) / sum( abs(A[A_nintercept]) <= tol )
            if (is_prec)
            {
                err_S_tmp[,j] = sqrt( apply ( Sigma_inv_matrix, 1, function(ai) sum ( ( ai - Sigma_inv ) * ( ai - Sigma_inv) )  ) / sum( Sigma_inv * Sigma_inv ) )
                err_all_tmp[,j] = sqrt( sapply ( 1:nrow(A_matrix), function(ai) sum ( ( c(A_matrix[ai,], Sigma_inv_matrix[ai,]) - c(A, Sigma_inv) ) * ( c(A_matrix[ai,], Sigma_inv_matrix[ai,]) - c(A, Sigma_inv)) )  ) / sum( c(A, Sigma_inv) * c(A, Sigma_inv) ) )
                tpr_S_tmp[,j] = apply ( Sigma_inv_matrix, 1, function(ai) sum ( abs(ai[S_ndiagonal]) > tol & abs(Sigma_inv[S_ndiagonal]) > tol )  ) / sum( abs(Sigma_inv[S_ndiagonal]) > tol )
                tnr_S_tmp[,j] = apply ( Sigma_inv_matrix, 1, function(ai) sum ( abs(ai[S_ndiagonal]) <= tol & abs(Sigma_inv[S_ndiagonal]) <= tol )  ) / sum( abs(Sigma_inv[S_ndiagonal]) <= tol )
                tpr_all_tmp[,j] = sapply ( 1:nrow(A_matrix), function(ai) sum ( abs(c(A_matrix[ai,][A_nintercept], Sigma_inv_matrix[ai,][S_ndiagonal])) > tol & abs(c(A[A_nintercept], Sigma_inv[S_ndiagonal])) > tol )  ) / sum( abs(c(A[A_nintercept], Sigma_inv[S_ndiagonal])) > tol )
                tnr_all_tmp[,j] = sapply ( 1:nrow(A_matrix), function(ai) sum ( abs(c(A_matrix[ai,][A_nintercept], Sigma_inv_matrix[ai,][S_ndiagonal])) <= tol & abs(c(A[A_nintercept], Sigma_inv[S_ndiagonal])) <= tol )  ) / sum( abs(c(A[A_nintercept], Sigma_inv[S_ndiagonal])) <= tol )
            } else
            {
                err_S_tmp[,j] = sqrt( apply ( Sigma_matrix, 1, function(ai) sum ( ( ai - Sigma ) * ( ai - Sigma) )  ) / sum( Sigma * Sigma ) )
                err_all_tmp[,j] = sqrt( sapply ( 1:nrow(A_matrix), function(ai) sum ( ( c(A_matrix[ai,], Sigma_matrix[ai,]) - c(A, Sigma) ) * ( c(A_matrix[ai,], Sigma_matrix[ai,]) - c(A, Sigma)) )  ) / sum( c(A, Sigma) * c(A, Sigma) ) )
                tpr_S_tmp[,j] = apply ( Sigma_matrix, 1, function(ai) sum ( abs(ai[S_ndiagonal]) > tol & abs(Sigma[S_ndiagonal]) > tol )  ) / sum( abs(Sigma[S_ndiagonal]) > tol )
                tnr_S_tmp[,j] = apply ( Sigma_matrix, 1, function(ai) sum ( abs(ai[S_ndiagonal]) <= tol & abs(Sigma[S_ndiagonal]) <= tol )  ) / sum( abs(Sigma[S_ndiagonal]) <= tol )
                tpr_all_tmp[,j] = sapply ( 1:nrow(A_matrix), function(ai) sum ( abs(c(A_matrix[ai,][A_nintercept], Sigma_matrix[ai,][S_ndiagonal])) > tol & abs(c(A[A_nintercept], Sigma[S_ndiagonal])) > tol )  ) / sum( abs(c(A[A_nintercept], Sigma[S_ndiagonal])) > tol )
                tnr_all_tmp[,j] = sapply ( 1:nrow(A_matrix), function(ai) sum ( abs(c(A_matrix[ai,][A_nintercept], Sigma_matrix[ai,][S_ndiagonal])) <= tol & abs(c(A[A_nintercept], Sigma[S_ndiagonal])) <= tol )  ) / sum( abs(c(A[A_nintercept], Sigma[S_ndiagonal])) <= tol )
            }
        }
        
        ind = 1:replics
        err_A = rbind( err_A, err_A_tmp[ ind,])
        err_S = rbind( err_S, err_S_tmp[ ind ,])
        err_Pr = rbind( err_Pr, err_Pr_tmp[ ind ,])
        err_all = rbind( err_all, err_all_tmp[ ind ,])
        tpr_A = rbind( tpr_A, tpr_A_tmp[ ind ,])
        tpr_S = rbind( tpr_S, tpr_S_tmp[ ind ,])
        tpr_all = rbind( tpr_all, tpr_all_tmp[ ind ,])
        tnr_A = rbind( tnr_A, tnr_A_tmp[ ind ,])
        tnr_S = rbind( tnr_S, tnr_S_tmp[ ind ,])
        tnr_all = rbind( tnr_all, tnr_all_tmp[ ind ,])
    }
    for(ci in 1:max(const_vec))
    {
        #Plots for Error, TPR, TNR
        title_str = ""
        data_dir_gg = paste0("./")
        
        is_prec = F
        if ( grepl("_pr_", data_dir_0, fixed = T) )
            is_prec = T
        
        col_tpr = c('#ffffff', '#99ccff', '#5588cc')
        col_err_mle = col_tpr
        col_err = col_tpr
        col_tnr = col_tpr
        dodge_width = 0.6
        bar_width = 0
        gg_substr = ""
        ylimits_ree = c(1.0, 2.5)
        ylimits_ee = c(0.0, 0.4)
        ylimits_pr = c(0.0, 0.2)
        ylimits_tpr = c(0.5, 1.0)
        ylimits_tnr = c(0.9, 1.0)
        if(!is_prec)
        {
            if(D==40)
            {
                ylimits_ree = c(1.0, 2.6)
                ylimits_ee = c(0.0, 0.3)
                ylimits_pr = c(0.0, 0.15)
                ylimits_tpr = c(0.55, 1.0)
                ylimits_tnr = c(0.95, 1.0)
            }
            if(D==100)
            {
                ylimits_ree = c(1.0, 2.8)
                ylimits_ee = c(0.0, 0.2)
                ylimits_pr = c(0.0, 0.1)
                ylimits_tpr = c(0.5, 1.0)
                ylimits_tnr = c(0.95, 1.0)
            }
            
        } else
        {
            ylimits_ree = c(0.0, 2.25)
            ylimits_ee = c(0.0, 0.35)
            ylimits_pr = c(0.0, 0.2)
            ylimits_tpr = c(0.65, 1.0)
            ylimits_tnr = c(0.95, 1.0)
            
            if(D==40)
            {
                ylimits_ree = c(0.0, 2.0)
                ylimits_ee = c(0.0, 0.45)
                ylimits_pr = c(0.0, 0.18)
                ylimits_tpr = c(0.7, 1.0)
                ylimits_tnr = c(0.95, 1.0)
            }
            if(D==100)
            {
                ylimits_ree = c(0.0, 2.1)
                ylimits_ee = c(0.0, 0.6)
                ylimits_pr = c(0.0, 0.12)
                ylimits_tpr = c(0.6, 1.0)
                ylimits_tnr = c(0.95, 1.0)
            }
            
        }
        
        #Error Relative to MLE/Oracle
        dataA = data.frame ( c(err_A), c (matrix(penalty_n, nrow = dim(err_A)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(err_A)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_err[1], const_vec )
        colnames(dataA) = c("Error", "Penalty", "N", "Param", "M")
        dataS = data.frame ( c(err_S), c (matrix(penalty_n, nrow = dim(err_S)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(err_S)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_err[2], const_vec )
        colnames(dataS) = c("Error", "Penalty", "N", "Param", "M")
        dataPr = data.frame ( c(err_Pr), c (matrix(penalty_n, nrow = dim(err_Pr)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(err_S)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_err[3], const_vec )
        colnames(dataPr) = c("Error", "Penalty", "N", "Param", "M")
        dataAll = data.frame ( c(err_all), c (matrix(penalty_n, nrow = dim(err_all)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(err_all)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_err[4], const_vec )
        colnames(dataAll) = c("Error", "Penalty", "N","Param", "M")
        
        Data = rbind(dataA[ dataA$M == ci, ], dataS[ dataS$M == ci, ], dataAll[ dataAll$M == ci, ])
        Data$Param = factor(Data$Param, levels = params_err[-3])
        Data$N = factor(Data$N, levels = nstr)
        Data$M = factor(Data$M)
        sumData = aggregate( Error ~ Penalty + N + Param, Data, mean )
        sumData = sumData[sumData$Penalty=="1mle_star",]
        #Get scaled by mle/oracle means
        for(j in 1:nrow(Data))
        {
            for( k in 1:nrow(sumData) )
            {
                if( Data[j,]$N == sumData[k,]$N && Data[j,]$Param == sumData[k,]$Param )
                {
                    Data[j ,]$Error = Data[ j, ]$Error / sumData[ k, ]$Error
                }
                
            }
        }
        Data = Data[Data$Penalty != "1mle_star",]
        gg_substr = ""
        shape_v = c(16, 17, 15)
        
        #x11()
        print(
        ggplot ( data = Data) + 
            geom_boxplot( aes( x = Penalty, y = Error, fill = N), fatten = 1.5, outlier.shape = NA ) +
            coord_cartesian(ylim = ylimits_ree) +
            scale_fill_manual(values = col_tpr) + 
            facet_wrap(vars(Param), dir = "h", scales = "fixed", shrink = T, drop = T) +
            ggtitle(paste0(gg_substr, title_str) ) +
            theme_bw() +
            theme(plot.title = element_text(hjust = 0.5), text = element_text(family = "Times", size = 15, colour = "gray30" ), axis.text.x = element_text(hjust = 0.5), legend.position = "right") + labs ( fill = "Sample size:") +
            scale_x_discrete( breaks = penalty_n, labels = penalty_labs) +
            scale_y_continuous(n.breaks = 8, labels = function(x) format(x, nsmall = 2)) +
            labs(x="", y="REE", color = "n", shape = "n", linetype = "n", group = "n") +
            scale_color_manual(values = col_err_mle) +
            scale_shape_manual(values = shape_v)
        )
        ggsave( paste0(data_dir_gg, "plot_REE.pdf"), device = "pdf", width = 10, height = 2.5, units = "in", dpi = 300)
        sumData = aggregate( Error ~ Penalty + N + Param, Data, median )
        colnames(sumData)[4] = "Median"
        sumData$Median = as.numeric(format(sumData$Median, nsmall = 4, digits = 5))
        sumData$Penalty[sumData$Penalty=="1mle_star"] = "MLE*"
        sumData$Penalty[sumData$Penalty=="2lasso"] = "LASSO"
        sumData$Penalty[sumData$Penalty=="3alasso"] = "ALASSO"
        sumData$Penalty[sumData$Penalty=="4scad"] = "SCAD"
        sumData$Penalty[sumData$Penalty=="5mcp"] = "MCP"
        #sumData = cbind(sumData, Median = sumData$Error)
        write.table( sumData, quote = F, file = paste0("table_REE.csv"), append = T, row.names = F , col.names = F, sep = ",")
        
        #Error
        Data = dataAll[ dataAll$M == ci, ]
        Data$Param = factor(Data$Param, levels = params_err[-3])
        Data$N = factor(Data$N, levels = nstr)
        Data$M = factor(Data$M)
        gg_substr = ""
        #x11()
        print(
          ggplot ( data = Data) + 
            geom_boxplot( aes( x = Penalty, y = Error, fill = N), fatten = 1.5, outlier.shape = NA ) +
            coord_cartesian(ylim = ylimits_ee) +
            scale_y_continuous(n.breaks = 8, labels = function(x) format(x, nsmall = 2)) +
            scale_fill_manual(values = col_tpr) +
            ggtitle(  title_str ) +
            theme_bw() +
            theme(plot.title = element_text(hjust = 0.5), text = element_text(family = "Times", size = 15, colour = "gray30"), axis.text.x = element_text(hjust = 0.5), legend.position = "right") + labs ( fill = "Sample size:") +
            scale_x_discrete( breaks = penalty_n, labels = penalty_labs) + 
            labs(x="", y="Overall EE", color = "n", shape = "n", linetype = "n", group = "n") +
            scale_color_manual(values = col_err) +
            scale_shape_manual(values = shape_v)
        )
        ggsave( paste0(data_dir_gg, "plot_EE_overall.pdf"), device = "pdf", width = 5, height = 2.5, units = "in", dpi = 300)
        sumData = aggregate( Error ~ Penalty + N + Param, Data, median )
        colnames(sumData)[4] = "Median"
        sumData$Median = as.numeric(format(sumData$Median, nsmall = 4, digits = 5))
        sumData$Penalty[sumData$Penalty=="1mle_star"] = "MLE*"
        sumData$Penalty[sumData$Penalty=="2lasso"] = "LASSO"
        sumData$Penalty[sumData$Penalty=="3alasso"] = "ALASSO"
        sumData$Penalty[sumData$Penalty=="4scad"] = "SCAD"
        sumData$Penalty[sumData$Penalty=="5mcp"] = "MCP"
        #sumData = cbind(sumData, Median = sumData$Error)
        write.table( sumData, quote = F, file = paste0("table_EE_overall.csv"), append = T, row.names = F , col.names = F, sep = ",")
        
        #Error Pr
        Data = dataPr[ dataPr$M == ci, ]
        Data$Param = factor(Data$Param, levels = params_err[3])
        Data$N = factor(Data$N, levels = nstr)
        Data$M = factor(Data$M)
        #x11()
        print(
        ggplot ( data = Data) +
            geom_boxplot( aes( x = Penalty, y = Error, fill = N), fatten = 1.5, outlier.shape = NA ) +
            coord_cartesian(ylim = ylimits_pr) +
            scale_y_continuous(n.breaks = 8, labels = function(x) format(x, nsmall = 2)) +
            scale_fill_manual(values = col_tpr) +
            ggtitle( title_str) +
            theme_bw() +
            theme(plot.title = element_text(hjust = 0.5), text = element_text(family = "Times", size = 15, colour = "gray30"), axis.text.x = element_text(hjust = 0.5), legend.position = "right") + labs ( fill = "Sample size:") +
            scale_x_discrete( breaks = penalty_n, labels = penalty_labs) +
            labs(x="", y="Trans. probab. EE", color = "n", shape = "n", linetype = "n", group = "n") +
            scale_color_manual(values = col_err) +
            scale_shape_manual(values = shape_v)
        )
        ggsave( paste0(data_dir_gg, "plot_EE_trans_prob.pdf"), device = "pdf", width = 5, height = 2.5, units = "in", dpi = 300)
        sumData = aggregate( Error ~ Penalty + N + Param, Data, median )
        colnames(sumData)[4] = "Median"
        sumData$Median = as.numeric(format(sumData$Median, nsmall = 4, digits = 5))
        sumData$Penalty[sumData$Penalty=="1mle_star"] = "MLE*"
        sumData$Penalty[sumData$Penalty=="2lasso"] = "LASSO"
        sumData$Penalty[sumData$Penalty=="3alasso"] = "ALASSO"
        sumData$Penalty[sumData$Penalty=="4scad"] = "SCAD"
        sumData$Penalty[sumData$Penalty=="5mcp"] = "MCP"
        #sumData = cbind(sumData, Median = sumData$Error)
        write.table( sumData, quote = F, file = paste0("table_EE_trans_probab.csv"), append = T, row.names = F , col.names = F, sep = ",")
        
        #TPR
        dataA = data.frame ( c(tpr_A), c (matrix(penalty_n, nrow = dim(tpr_A)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(tpr_A)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_tr[1], const_vec )
        colnames(dataA) = c("TPR", "Penalty", "N","Param", "M")
        dataS = data.frame ( c(tpr_S), c (matrix(penalty_n, nrow = dim(tpr_S)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(tpr_S)[1] / length(nstr), ncol = length(nstr), byrow = T) ),params_tr[2], const_vec )
        colnames(dataS) = c("TPR", "Penalty", "N", "Param", "M")
        dataAll = data.frame ( c(tpr_all), c (matrix(penalty_n, nrow = dim(tpr_all)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(tpr_all)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_tr[4], const_vec )
        colnames(dataAll) = c("TPR", "Penalty", "N","Param", "M")
        Data = rbind(dataA[ dataA$Penalty != penalty_n[1], ], dataS[ dataS$Penalty != penalty_n[1], ], dataAll[ dataAll$Penalty != penalty_n[1], ])
        Data = Data[ Data$M == ci, ]
        Data$Param = factor(Data$Param, levels = params_tr[-3])
        Data$N = factor(Data$N, levels = nstr)
        Data$M = factor(Data$M)
        gg_substr = ""
        #x11()
        print(
          ggplot ( data = Data) + 
            geom_boxplot( aes( x = Penalty, y = TPR, fill = N), fatten = 1.5, outlier.shape = NA ) +
            coord_cartesian(ylim = ylimits_tpr) +
            scale_fill_manual(values = col_tpr) +
            ggtitle( paste0(gg_substr,title_str) ) +
            theme_bw() +
            theme(plot.title = element_text(hjust = 0.5), text = element_text(family = "Times", size = 15, colour = "gray30"), axis.text.x = element_text(hjust = 0.5), legend.position = "right") + labs ( fill = "Sample size:") +
            scale_x_discrete( breaks = penalty_n, labels = penalty_labs) +
            facet_wrap(vars(Param), dir = "h", scales = "fixed", shrink = T, drop = T) +
            scale_y_continuous(n.breaks = 8, labels = function(x) format(x, nsmall = 2)) +
            labs(x="", y="TPR", color = "n", shape = "n", linetype = "n", group = "n") +
            scale_color_manual(values = col_tpr) +
            scale_shape_manual(values = shape_v)
          )
        ggsave(paste0(data_dir_gg, "plot_TPR.pdf"), device = "pdf", width = 10, height = 2.5, units = "in", dpi = 300)
        sumData = aggregate( TPR ~ Penalty + N + Param, Data, median )
        colnames(sumData)[4] = "Median"
        sumData$Median = as.numeric(format(sumData$Median, nsmall = 4, digits = 5))
        sumData$Penalty[sumData$Penalty=="1mle_star"] = "MLE*"
        sumData$Penalty[sumData$Penalty=="2lasso"] = "LASSO"
        sumData$Penalty[sumData$Penalty=="3alasso"] = "ALASSO"
        sumData$Penalty[sumData$Penalty=="4scad"] = "SCAD"
        sumData$Penalty[sumData$Penalty=="5mcp"] = "MCP"
        #sumData = cbind(sumData, Median = sumData$TPR)
        write.table( sumData, quote = F, file = paste0("table_TPR.csv"), append = T, row.names = F , col.names = F, sep = ",")
        
        #TNR
        dataA = data.frame ( c(tnr_A), c (matrix(penalty_n, nrow = dim(tnr_A)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(tnr_A)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_tr[1], const_vec )
        colnames(dataA) = c("TNR", "Penalty", "N", "Param", "M")
        dataS = data.frame ( c(tnr_S), c (matrix(penalty_n, nrow = dim(tnr_S)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(tnr_S)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_tr[2], const_vec )
        colnames(dataS) = c("TNR", "Penalty", "N", "Param", "M")
        dataAll = data.frame ( c(tnr_all), c (matrix(penalty_n, nrow = dim(tnr_all)[1], ncol = length(penalty), byrow = T) ), c (matrix(nstr, nrow = dim(tnr_all)[1] / length(nstr), ncol = length(nstr), byrow = T) ), params_tr[4], const_vec )
        colnames(dataAll) = c("TNR", "Penalty", "N", "Param", "M")
        Data = rbind(dataA[ dataA$Penalty != penalty_n[1], ], dataS[ dataS$Penalty != penalty_n[1], ], dataAll[ dataAll$Penalty != penalty_n[1], ])
        Data = Data[ Data$M == ci, ]
        Data$Param = factor(Data$Param, levels = params_tr[-3])
        Data$N = factor(Data$N, levels = nstr)
        Data$M = factor(Data$M)
        gg_substr = ""
        #x11()
        print(
          ggplot ( data = Data) + 
            geom_boxplot( aes( x = Penalty, y = TNR, fill = N), fatten = 1.5, outlier.shape = NA ) +
            coord_cartesian(ylim = ylimits_tnr) +
            scale_fill_manual(values = col_tpr) +
            ggtitle(paste0(gg_substr,title_str)) +
            theme_bw() +
            theme(plot.title = element_text(hjust = 0.5), text = element_text(family = "Times", size = 15, colour = "gray30"), axis.text.x = element_text(hjust = 0.5), legend.position = "right") + labs( fill = "Sample size:") +
            scale_x_discrete( breaks = penalty_n, labels = penalty_labs) +
            facet_wrap(vars(Param), dir = "h", scales = "fixed", shrink = T, drop = T) +
            scale_y_continuous(n.breaks = 8, labels = function(x) format(x, nsmall = 2)) +
            labs(x="", y="TNR", color = "n", shape = "n", linetype = "n", group = "n") +
            scale_color_manual(values = col_tnr) +
            scale_shape_manual(values = shape_v)
          )
        ggsave(paste0(data_dir_gg, "plot_TNR.pdf"), device = "pdf", width = 10, height = 2.5, units = "in", dpi = 300)
        sumData = aggregate( TNR ~ Penalty + N + Param, Data, median )
        colnames(sumData)[4] = "Median"
        #sumData = cbind(sumData, Median = sumData$TNR)
        sumData$Median = as.numeric(format(sumData$Median, nsmall = 4, digits = 5))
        sumData$Penalty[sumData$Penalty=="1mle_star"] = "MLE*"
        sumData$Penalty[sumData$Penalty=="2lasso"] = "LASSO"
        sumData$Penalty[sumData$Penalty=="3alasso"] = "ALASSO"
        sumData$Penalty[sumData$Penalty=="4scad"] = "SCAD"
        sumData$Penalty[sumData$Penalty=="5mcp"] = "MCP"
        write.table( sumData, quote = F, file = paste0("table_TNR.csv"), append = T, row.names = F , col.names = F, sep = ",")
    }
    print(paste0("Files written to working directory ", data_dir_gg), quote = F)
    #####################
}
##
#
